/*
 * Copyright 2017-2018 Intel Corporation
 *
 * This software and the related documents are Intel copyrighted materials, and
 * your use of them is governed by the express license under which they were
 * provided to you (License). Unless the License provides otherwise, you may
 * not use, modify, copy, publish, distribute, disclose, or transmit this
 * software or the related documents without Intel's prior written permission.
 *
 * This software and the related documents are provided as is, with no express
 * or implied warranties, other than those that are expressly stated in the
 * License.
 */

#ifndef _CLCK_NODE_H
#define _CLCK_NODE_H

#include <string>
#include <vector>

namespace clck {

    // Pre-defined roles
    const std::string ROLE_BOOT = "boot";
    const std::string ROLE_COMPUTE = "compute";
    const std::string ROLE_ENHANCED = "enhanced";
    const std::string ROLE_EXTERNAL = "external";
    const std::string ROLE_HEAD = "head";
    const std::string ROLE_JOB_SCHEDULER = "job_schedule";
    const std::string ROLE_LOGIN = "login";
    const std::string ROLE_NETWORK_ADDRESS = "network_address";
    const std::string ROLE_STORAGE = "storage";

    // @brief The node container.
    class Node {
    public:
        // A subcluster to which the node belongs.
        std::string subcluster;

        // An unique node identifier, i.e., the hostname.
        std::string name;

        // A list of roles that the node fulfills.
        std::vector<std::string> roles = {};
    };
}

#endif //_CLCK_NODE_H
