; Copyright 2018 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defclass DEVICES
  "This class represents devices found by lspci_verbose"
  (is-a BASE_NODE BASE_TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)
  
  (slot err (type STRING) (default ""))
  ; device index
  (multislot device_idxs (type NUMBER) (visibility public))
  ; PCIe device type
  (multislot device_types (type SYMBOL) (visibility public))
  ; PCIe device id
  (multislot device_ids (type NUMBER) (visibility public))
  ; PCIe linkcap width
  (multislot lnkcap_width (type STRING) (visibility public))
)

(defmessage-handler DEVICES get-device-id-by-idx(?idx)
  (return (nth$ ?idx ?self:device_ids)))

(defmessage-handler DEVICES get-device-type-by-idx(?idx)
  (return (nth$ ?idx ?self:device_types)))

(defmessage-handler DEVICES get-device-width-by-idx(?idx)
  (return (nth$ ?idx ?self:lnkcap_width)))
