; Copyright 2006-2018 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule latest-ssf-version
  "Determine whether the self-identified Intel(R) Scalable System
   Framework version contains the latest version (2016.0)."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ssf_version $?))
  ?obj <- (object (is-a SSF) (node_id ?node) (ssf-version $?ssfversion)
                  (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (or (= (length$ ?ssfversion) 0)
            (!= (str-compare "2016.0" (send ?obj maximum-version)) 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value FALSE)
                 (id "latest-ssf-version")))

