; Copyright 2006-2018 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ssf-file-not-found
  "If no Intel(R) Scalable System Framework versions are found and stderr contains
   the string 'No such file or directory', then the file is missing."
  (object (is-a CONFIG) (name [config]) (ssf-version ?iv&2016.0 )
          (clck-checks $? ssf_version $?))
  ?obj <- (object (is-a SSF) (node_id ?node) (ssf-version $?ssf-version)
                  (stderr ?err) (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (and (= (length$ ?ssf-version) 0)
             (str-index "No such file or directory" ?err)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (args (create$ ?iv))
                 (remedy "ssf-file-error-remedy")
                 (id "ssf-file-not-found")))

