#!/bin/bash

# Copyright (C) 2016-2018 Intel Corporation. All Rights Reserved.
#
# The  source code contained or described  herein and all documents  related to
# the source code ('Material') are owned by Intel  Corporation or its suppliers
# or licensors.  Title to the Material  remains  with Intel  Corporation or its
# suppliers and licensors. The Material is protected by worldwide copyright and
# trade secret laws and treaty provisions. No part of the Material may be used,
# copied,  reproduced,  modified,  published,  uploaded,  posted,  transmitted,
# distributed,  or disclosed in any way without  Intel's prior express  written
# permission.
#
# No license under any patent,  copyright,  trade secret or other  intellectual
# property  right is granted to or conferred upon you by disclosure or delivery
# of the Materials,  either expressly, by implication,  inducement, estoppel or
# otherwise.  Any license  under  such  intellectual  property  rights  must be
# express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing, you may not remove or alter this
# notice  or  any  other  notice  embedded  in  Materials  by Intel or  Intel's
# suppliers or licensors in any way.

. $(dirname $0)/../../functions
if [ ${UID} != "0" ]; then
    _stderr "Root access is required for dmidecode to run properly."
    exit 1
fi

function main {
# Memory
\dmidecode -t 17 |\grep -e Handle -A 16 |\grep -e Handle -e Manufacturer -e "Serial" |\grep -v -e Array -e Error |\sed -e 's/^[[:space:]]*//' |tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

#processor
\dmidecode -t 4 |\grep -e Handle -e ID -e Version |\grep -v -e Cache |\sed -e 's/^[[:space:]]*//' |\tr '\n' ' ' |\sed 's/Handle/\n/g'

#BIOS
\dmidecode -t 0 |\grep -e Handle -e "BIOS Information" -e Version |\sed -e 's/^[[:space:]]*//' |\tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

#Base Board
\dmidecode -t 2 |\grep -e Handle -e "Base Board Information" -e Manufacturer -e "Product Name" -e Version |\grep -v -e Chassis -e Object |\sed -e 's/^[[:space:]]*//' |tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

echo
#pci
\lspci -m |\awk -F\" '{print $1=$1", " $4 " " $6 }' |\sed 's/ ,/,/g'
}

main $@ |\sort |\sed -e 's/^[[:space:]]*//' |\sed -e "1 d"

