#!/bin/bash
# Copyright 2015-2018 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

. $(dirname $0)/../../functions


if [[ "$CLCK_PROVIDER_OPASMAQUERY_PATH" == "" ]]; then
    get_tool_path "opasmaquery"
    SMA_BINARY=$tool_path
else
    SMA_BINARY="${CLCK_PROVIDER_OPASMAQUERY_PATH}/opasmaquery"
fi


# Use opainfo to get the number of hfi seen by the system.
# The system sees different ports as seperate HFI devices
# If they are from the same card they will have an identical
# SystemImage.


# Run opasmaquery  using -h to force to default hfi port
# and the -p lets us cycle through all available ports on
# the system.
# HFI's and with -g to force flag output.
i=1
res=0

while [ $res -eq 0 ]; do
    ${SMA_BINARY} -g -h 0 -p $i -o nodeinfo > /dev/null 2>&1
    res=$?
    if  [ $res -eq 0 ]; then
        echo "####LOOKING AT PORT $i####"
        ${SMA_BINARY} -g -h 0 -p $i -o nodeinfo
        ${SMA_BINARY} -g -h 0 -p $i -o portinfo
        echo "####END PORT $i####"
        i=$((i + 1))
    fi
done
